require 'tempfile'
require_relative '../spec_helper'
require_relative '../../../libraries/config'

describe Manage::Config do
  describe 'support_site_url' do
    context 'when not in config file' do
      it 'is http://getchef.com/support' do
        expect(described_class.support_site_url).to eq 'http://getchef.com/support'
      end
    end

    context 'when in the config file' do
      let(:config_file) { Tempfile.new('manage.rb') }

      before :each do
        config_file.open
        config_file.write("support_site_url 'http://support.test.com'")
        config_file.close
      end

      after :each do
        config_file.unlink
      end

      it 'is the value from the file' do
        described_class.from_file(config_file.path)
        expect(described_class.support_site_url).to eq 'http://support.test.com'
      end
    end
  end

  # These are not done because of a weird error
#  describe 'secrets_from_file' do
    #context 'when the secrets file does not exist' do
      #it 'creates the file'
      #it 'adds the secret_token to the file'
      #it 'adds the secret token to the config'
    #end

    #context 'when the secrets file exists' do
      #it 'adds the secret token to the config'
    #end
  #end
end
