require_relative '../spec_helper'

describe 'omnibus-chef-manage::default' do
  let(:chef_run) do
    ChefSpec::SoloRunner.new do |node|
      set_default_attributes_for(node)
    end.converge(described_recipe)
  end

  before :each do
    stub_command("grep 'CM:123456:respawn:/opt/chef-manage/embedded/bin/runsvdir-start' /etc/inittab")
  end

  # These are actually rendered in the private_chef_addon cookbook, but that
  # cookbook is deprecated and has no tests, so we're testing for the behavior
  # we want in this cookbook

  it 'creates the base etc directory' do
    expect(chef_run).to create_directory('/var/opt/chef-manage/etc')
  end

  it 'renders chef-manage-running.json' do
    expect(chef_run).to create_file(
      '/var/opt/chef-manage/etc/chef-manage-running.json'
    ).with(
      group: 'root',
      mode: '0600',
    )
  end
end
