require 'chefspec'
require 'chefspec/berkshelf'
require 'chefspec/deprecations'

module NodeHelper
  def set_default_attributes_for(node)
    node.set['cpu']['total'] = '4'
    node.set['chef-manage']['install_path'] = '/opt/chef-manage'
    node.set['chef-manage']['config_path'] = '/var/opt/chef-manage/etc'
    node.set['chef-manage']['user']['username'] = 'chef'
    node.set['chef-manage']['var_path'] = '/var/opt/chef-manage'
    node.set['private_chef']['lb']['api_fqdn'] = 'example.com'
    node.set['private_chef']['ldap'] = {}
    node.set['private_chef']['nginx']['dir'] = '/var/opt/opscode/nginx'
    node.set['private_chef']['nginx']['ssl_port'] = 443
    node.set['private_chef']['opscode-webui']['enable'] = false
    node.set['runit']['sv_bin'] = '/usr/bin/sv'
  end
end

RSpec.configure do |config|
  config.include NodeHelper
  config.cookbook_path = "#{File.dirname(__FILE__)}/../../.."
end
