require 'yaml'
require 'spec_helper'

describe file('/var/opt/chef-manage/etc/settings.yml') do
  it { should be_file }
end

describe file('/opt/chef-manage/embedded/service/chef-manage/config/settings/production.yml') do
  it { should be_linked_to '/var/opt/chef-manage/etc/settings.yml' }
end

describe 'config' do
  let(:config) do
    YAML.load_file('/var/opt/chef-manage/etc/settings.yml')
  end

  describe 'support_email_address' do
    it 'should be written to the config file' do
      expect(config['support_email_address']).to eq 'test@test.com'
    end
  end
end
