define (require) ->
  Modal         = require('views/controls/modals/base')
  RunListEditor = require('views/controls/run_list_editor')
  template      = require('j!controls/modals/edit_run_list')

  class EditRunListModal extends Modal
    template: template
    events: 'click .btn-primary': 'submit'

    initialize: (options) ->
      @model = @collection.at(0)
      @environment = '_default'
      @organization = options.app.organizations.last()
      @runList = @model.get('run_list')
      @runListEditor = new RunListEditor(
        { @environment, @model, @organization }
      )
      super()

    beforeRender: ->
      @setView('.modal-body', @runListEditor)

    getProcessedRunList: ->
      @model.get('run_list').map (item) -> "#{item.type}[#{item.name}]"

    submit: ->
      @queueAction('edit_run_list', @getProcessedRunList())
      @remove()
