class EnvironmentsController < ChefSolrSearchableObjectController
  def recipes
    @recipes = server.get_rest("environments/#{params[:id]}/recipes")
    render :json => @recipes
  end

  def create
    begin
      environment = Chef::Environment.json_create(params)
      server.post('environments', environment)
      render json: environment.to_hash, status: :created
    rescue Chef::Exceptions::ValidationFailed => e
      render json: { error: e.message }, status: :forbidden
    end
  end

  def update
    begin
      environment = Chef::Environment.json_create(params)
      server.put("environments/#{params[:id]}", environment)
      render json: environment.to_hash
    rescue Chef::Exceptions::ValidationFailed => e
      render json: { error: e.message }, status: :forbidden
    end
  end

  protected

  def object_type
    'environment'
  end

  def searchable_fields
    ['name', 'description']
  end

  def index_url
    "environments"
  end
end
