class RolesController < ChefSolrSearchableObjectController
  include RunlistHelper

  def create
    role = Chef::Role.json_create(params)
    server.post('roles', role)
    render json: role.to_hash, status: :created
  end

  protected

  def object_type
    'role'
  end

  def searchable_fields
    ['name', 'description', 'environment']
  end

  def index_url
    "roles"
  end

  def run_lists_for_object(role)
    role.env_run_lists
  end
end
