require 'raven_settings'

Chef::Manage::Application.configure do
  Raven.configure do |raven_config|
    if RavenSettings.dsn.present?
      raven_config.dsn = RavenSettings.dsn
      raven_config.environments = [Rails.env]
    else
      raven_config.environments = []
    end
    raven_config.logger = Rails.logger
    raven_config.ssl_verification = false
    raven_config.processors = [Raven::Processor::SanitizeData]

    # Ignore errors from the Chef server by default. We filter and selectively
    # send errors in the rescue_from handler in the application controller.
    raven_config.excluded_exceptions = Raven::Configuration::IGNORE_DEFAULT <<
      'Net::HTTPServerException'
  end
end
