# -*- encoding: utf-8 -*-
# stub: veil 0.3.0 ruby lib

Gem::Specification.new do |s|
  s.name = "veil"
  s.version = "0.3.0"

  s.required_rubygems_version = Gem::Requirement.new(">= 0") if s.respond_to? :required_rubygems_version=
  s.require_paths = ["lib"]
  s.authors = ["Chef Software, Inc."]
  s.date = "2017-03-30"
  s.description = "Veil is a Ruby Gem for generating secure secrets from a shared secret"
  s.email = ["partnereng@chef.io"]
  s.executables = ["console", "setup", "veil-dump-secrets", "veil-env-helper", "veil-ingest-secret"]
  s.files = ["LICENSE", "bin/console", "bin/setup", "bin/veil-dump-secrets", "bin/veil-env-helper", "bin/veil-ingest-secret", "lib/veil.rb", "lib/veil/cipher.rb", "lib/veil/cipher/v1.rb", "lib/veil/cipher/v2.rb", "lib/veil/credential.rb", "lib/veil/credential_collection.rb", "lib/veil/credential_collection/base.rb", "lib/veil/credential_collection/chef_secrets_env.rb", "lib/veil/credential_collection/chef_secrets_file.rb", "lib/veil/exceptions.rb", "lib/veil/hasher.rb", "lib/veil/hasher/base.rb", "lib/veil/hasher/bcrypt.rb", "lib/veil/hasher/pbkdf2.rb", "lib/veil/utils.rb", "lib/veil/version.rb", "spec/cipher/v1_spec.rb", "spec/cipher/v2_spec.rb", "spec/cipher_spec.rb", "spec/credential_collection/base_spec.rb", "spec/credential_collection/chef_secrets_env_spec.rb", "spec/credential_collection/chef_secrets_file_spec.rb", "spec/credential_collection_spec.rb", "spec/credential_spec.rb", "spec/hasher/base_spec.rb", "spec/hasher/bcrypt_spec.rb", "spec/hasher/pbkdf2_spec.rb", "spec/hasher_spec.rb", "spec/spec_helper.rb", "spec/utils_spec.rb", "spec/veil_spec.rb"]
  s.homepage = "https://github.com/chef/chef-server/"
  s.licenses = ["Apache-2.0"]
  s.rubygems_version = "2.4.8"
  s.summary = "Veil is a Ruby Gem for generating secure secrets from a shared secret"
  s.test_files = ["spec/cipher/v1_spec.rb", "spec/cipher/v2_spec.rb", "spec/cipher_spec.rb", "spec/credential_collection/base_spec.rb", "spec/credential_collection/chef_secrets_env_spec.rb", "spec/credential_collection/chef_secrets_file_spec.rb", "spec/credential_collection_spec.rb", "spec/credential_spec.rb", "spec/hasher/base_spec.rb", "spec/hasher/bcrypt_spec.rb", "spec/hasher/pbkdf2_spec.rb", "spec/hasher_spec.rb", "spec/spec_helper.rb", "spec/utils_spec.rb", "spec/veil_spec.rb"]

  if s.respond_to? :specification_version then
    s.specification_version = 4

    if Gem::Version.new(Gem::VERSION) >= Gem::Version.new('1.2.0') then
      s.add_runtime_dependency(%q<bcrypt>, ["~> 3.1"])
      s.add_runtime_dependency(%q<pbkdf2>, [">= 0"])
      s.add_development_dependency(%q<bundler>, [">= 0"])
      s.add_development_dependency(%q<rake>, [">= 0"])
      s.add_development_dependency(%q<rspec>, ["~> 3.0"])
    else
      s.add_dependency(%q<bcrypt>, ["~> 3.1"])
      s.add_dependency(%q<pbkdf2>, [">= 0"])
      s.add_dependency(%q<bundler>, [">= 0"])
      s.add_dependency(%q<rake>, [">= 0"])
      s.add_dependency(%q<rspec>, ["~> 3.0"])
    end
  else
    s.add_dependency(%q<bcrypt>, ["~> 3.1"])
    s.add_dependency(%q<pbkdf2>, [">= 0"])
    s.add_dependency(%q<bundler>, [">= 0"])
    s.add_dependency(%q<rake>, [">= 0"])
    s.add_dependency(%q<rspec>, ["~> 3.0"])
  end
end
